<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ModifyScheduledRecurringPayment_PaymentMethodProfile
 * StructType
 * @subpackage Structs
 */
class ModifyScheduledRecurringPayment_PaymentMethodProfile extends AbstractStructBase
{
    /**
     * The securityToken
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\SecurityToken
     */
    public $securityToken;
    /**
     * The scheduledPaymentInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $scheduledPaymentInternalId;
    /**
     * The paymentMethodProfileId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $paymentMethodProfileId;
    /**
     * Constructor method for ModifyScheduledRecurringPayment_PaymentMethodProfile
     * @uses ModifyScheduledRecurringPayment_PaymentMethodProfile::setSecurityToken()
     * @uses ModifyScheduledRecurringPayment_PaymentMethodProfile::setScheduledPaymentInternalId()
     * @uses ModifyScheduledRecurringPayment_PaymentMethodProfile::setPaymentMethodProfileId()
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @param string $scheduledPaymentInternalId
     * @param string $paymentMethodProfileId
     */
    public function __construct(\eBizCharge\StructType\SecurityToken $securityToken = null, $scheduledPaymentInternalId = null, $paymentMethodProfileId = null)
    {
        $this
            ->setSecurityToken($securityToken)
            ->setScheduledPaymentInternalId($scheduledPaymentInternalId)
            ->setPaymentMethodProfileId($paymentMethodProfileId);
    }
    /**
     * Get securityToken value
     * @return \eBizCharge\StructType\SecurityToken|null
     */
    public function getSecurityToken()
    {
        return $this->securityToken;
    }
    /**
     * Set securityToken value
     * @param \eBizCharge\StructType\SecurityToken $securityToken
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_PaymentMethodProfile
     */
    public function setSecurityToken(\eBizCharge\StructType\SecurityToken $securityToken = null)
    {
        $this->securityToken = $securityToken;
        return $this;
    }
    /**
     * Get scheduledPaymentInternalId value
     * @return string|null
     */
    public function getScheduledPaymentInternalId()
    {
        return $this->scheduledPaymentInternalId;
    }
    /**
     * Set scheduledPaymentInternalId value
     * @param string $scheduledPaymentInternalId
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_PaymentMethodProfile
     */
    public function setScheduledPaymentInternalId($scheduledPaymentInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($scheduledPaymentInternalId) && !is_string($scheduledPaymentInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scheduledPaymentInternalId, true), gettype($scheduledPaymentInternalId)), __LINE__);
        }
        $this->scheduledPaymentInternalId = $scheduledPaymentInternalId;
        return $this;
    }
    /**
     * Get paymentMethodProfileId value
     * @return string|null
     */
    public function getPaymentMethodProfileId()
    {
        return $this->paymentMethodProfileId;
    }
    /**
     * Set paymentMethodProfileId value
     * @param string $paymentMethodProfileId
     * @return \eBizCharge\StructType\ModifyScheduledRecurringPayment_PaymentMethodProfile
     */
    public function setPaymentMethodProfileId($paymentMethodProfileId = null)
    {
        // validation for constraint: string
        if (!is_null($paymentMethodProfileId) && !is_string($paymentMethodProfileId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paymentMethodProfileId, true), gettype($paymentMethodProfileId)), __LINE__);
        }
        $this->paymentMethodProfileId = $paymentMethodProfileId;
        return $this;
    }
}
