<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SurchargeSettingsResponse StructType
 * @subpackage Structs
 */
class SurchargeSettingsResponse extends AbstractStructBase
{
    /**
     * The IsSurchargeEnabled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsSurchargeEnabled;
    /**
     * The SurchargeCountryId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeCountryId;
    /**
     * The SurchargePercentage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargePercentage;
    /**
     * The SurchargeTermsNote
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeTermsNote;
    /**
     * The SurchargeCaption
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeCaption;
    /**
     * The SurchargeTypeId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeTypeId;
    /**
     * Constructor method for SurchargeSettingsResponse
     * @uses SurchargeSettingsResponse::setIsSurchargeEnabled()
     * @uses SurchargeSettingsResponse::setSurchargeCountryId()
     * @uses SurchargeSettingsResponse::setSurchargePercentage()
     * @uses SurchargeSettingsResponse::setSurchargeTermsNote()
     * @uses SurchargeSettingsResponse::setSurchargeCaption()
     * @uses SurchargeSettingsResponse::setSurchargeTypeId()
     * @param bool $isSurchargeEnabled
     * @param string $surchargeCountryId
     * @param string $surchargePercentage
     * @param string $surchargeTermsNote
     * @param string $surchargeCaption
     * @param string $surchargeTypeId
     */
    public function __construct($isSurchargeEnabled = null, $surchargeCountryId = null, $surchargePercentage = null, $surchargeTermsNote = null, $surchargeCaption = null, $surchargeTypeId = null)
    {
        $this
            ->setIsSurchargeEnabled($isSurchargeEnabled)
            ->setSurchargeCountryId($surchargeCountryId)
            ->setSurchargePercentage($surchargePercentage)
            ->setSurchargeTermsNote($surchargeTermsNote)
            ->setSurchargeCaption($surchargeCaption)
            ->setSurchargeTypeId($surchargeTypeId);
    }
    /**
     * Get IsSurchargeEnabled value
     * @return bool
     */
    public function getIsSurchargeEnabled()
    {
        return $this->IsSurchargeEnabled;
    }
    /**
     * Set IsSurchargeEnabled value
     * @param bool $isSurchargeEnabled
     * @return \eBizCharge\StructType\SurchargeSettingsResponse
     */
    public function setIsSurchargeEnabled($isSurchargeEnabled = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSurchargeEnabled) && !is_bool($isSurchargeEnabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSurchargeEnabled, true), gettype($isSurchargeEnabled)), __LINE__);
        }
        $this->IsSurchargeEnabled = $isSurchargeEnabled;
        return $this;
    }
    /**
     * Get SurchargeCountryId value
     * @return string|null
     */
    public function getSurchargeCountryId()
    {
        return $this->SurchargeCountryId;
    }
    /**
     * Set SurchargeCountryId value
     * @param string $surchargeCountryId
     * @return \eBizCharge\StructType\SurchargeSettingsResponse
     */
    public function setSurchargeCountryId($surchargeCountryId = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeCountryId) && !is_string($surchargeCountryId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeCountryId, true), gettype($surchargeCountryId)), __LINE__);
        }
        $this->SurchargeCountryId = $surchargeCountryId;
        return $this;
    }
    /**
     * Get SurchargePercentage value
     * @return string|null
     */
    public function getSurchargePercentage()
    {
        return $this->SurchargePercentage;
    }
    /**
     * Set SurchargePercentage value
     * @param string $surchargePercentage
     * @return \eBizCharge\StructType\SurchargeSettingsResponse
     */
    public function setSurchargePercentage($surchargePercentage = null)
    {
        // validation for constraint: string
        if (!is_null($surchargePercentage) && !is_string($surchargePercentage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargePercentage, true), gettype($surchargePercentage)), __LINE__);
        }
        $this->SurchargePercentage = $surchargePercentage;
        return $this;
    }
    /**
     * Get SurchargeTermsNote value
     * @return string|null
     */
    public function getSurchargeTermsNote()
    {
        return $this->SurchargeTermsNote;
    }
    /**
     * Set SurchargeTermsNote value
     * @param string $surchargeTermsNote
     * @return \eBizCharge\StructType\SurchargeSettingsResponse
     */
    public function setSurchargeTermsNote($surchargeTermsNote = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeTermsNote) && !is_string($surchargeTermsNote)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeTermsNote, true), gettype($surchargeTermsNote)), __LINE__);
        }
        $this->SurchargeTermsNote = $surchargeTermsNote;
        return $this;
    }
    /**
     * Get SurchargeCaption value
     * @return string|null
     */
    public function getSurchargeCaption()
    {
        return $this->SurchargeCaption;
    }
    /**
     * Set SurchargeCaption value
     * @param string $surchargeCaption
     * @return \eBizCharge\StructType\SurchargeSettingsResponse
     */
    public function setSurchargeCaption($surchargeCaption = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeCaption) && !is_string($surchargeCaption)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeCaption, true), gettype($surchargeCaption)), __LINE__);
        }
        $this->SurchargeCaption = $surchargeCaption;
        return $this;
    }
    /**
     * Get SurchargeTypeId value
     * @return string|null
     */
    public function getSurchargeTypeId()
    {
        return $this->SurchargeTypeId;
    }
    /**
     * Set SurchargeTypeId value
     * @param string $surchargeTypeId
     * @return \eBizCharge\StructType\SurchargeSettingsResponse
     */
    public function setSurchargeTypeId($surchargeTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeTypeId) && !is_string($surchargeTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeTypeId, true), gettype($surchargeTypeId)), __LINE__);
        }
        $this->SurchargeTypeId = $surchargeTypeId;
        return $this;
    }
}
